// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.21.12
// source: proto/master/seats/seats.proto

package seats

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// SeatsServiceClient is the client API for SeatsService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type SeatsServiceClient interface {
	CreateSeatsUpdate(ctx context.Context, in *CreateSeatsUpdateRequest, opts ...grpc.CallOption) (*Seats, error)
	ReverseSeatsUpdate(ctx context.Context, in *ReverseSeatsUpdateRequest, opts ...grpc.CallOption) (*ReverseSeatsUpdateResponse, error)
	GetSeatsByID(ctx context.Context, in *SeatsIdentifierRequest, opts ...grpc.CallOption) (*Seats, error)
	GetSeatsByTicketID(ctx context.Context, in *SeatsIdentifierByTicketIDRequest, opts ...grpc.CallOption) (*Seats, error)
	GetSeatsByTransportID(ctx context.Context, in *SeatsIdentifierByTransportIDRequest, opts ...grpc.CallOption) (*ListSeats, error)
	GetSeatsAll(ctx context.Context, in *SeatsFilterQuery, opts ...grpc.CallOption) (*ListSeats, error)
}

type seatsServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewSeatsServiceClient(cc grpc.ClientConnInterface) SeatsServiceClient {
	return &seatsServiceClient{cc}
}

func (c *seatsServiceClient) CreateSeatsUpdate(ctx context.Context, in *CreateSeatsUpdateRequest, opts ...grpc.CallOption) (*Seats, error) {
	out := new(Seats)
	err := c.cc.Invoke(ctx, "/master.seats.SeatsService/CreateSeatsUpdate", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *seatsServiceClient) ReverseSeatsUpdate(ctx context.Context, in *ReverseSeatsUpdateRequest, opts ...grpc.CallOption) (*ReverseSeatsUpdateResponse, error) {
	out := new(ReverseSeatsUpdateResponse)
	err := c.cc.Invoke(ctx, "/master.seats.SeatsService/ReverseSeatsUpdate", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *seatsServiceClient) GetSeatsByID(ctx context.Context, in *SeatsIdentifierRequest, opts ...grpc.CallOption) (*Seats, error) {
	out := new(Seats)
	err := c.cc.Invoke(ctx, "/master.seats.SeatsService/GetSeatsByID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *seatsServiceClient) GetSeatsByTicketID(ctx context.Context, in *SeatsIdentifierByTicketIDRequest, opts ...grpc.CallOption) (*Seats, error) {
	out := new(Seats)
	err := c.cc.Invoke(ctx, "/master.seats.SeatsService/GetSeatsByTicketID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *seatsServiceClient) GetSeatsByTransportID(ctx context.Context, in *SeatsIdentifierByTransportIDRequest, opts ...grpc.CallOption) (*ListSeats, error) {
	out := new(ListSeats)
	err := c.cc.Invoke(ctx, "/master.seats.SeatsService/GetSeatsByTransportID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *seatsServiceClient) GetSeatsAll(ctx context.Context, in *SeatsFilterQuery, opts ...grpc.CallOption) (*ListSeats, error) {
	out := new(ListSeats)
	err := c.cc.Invoke(ctx, "/master.seats.SeatsService/GetSeatsAll", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// SeatsServiceServer is the server API for SeatsService service.
// All implementations must embed UnimplementedSeatsServiceServer
// for forward compatibility
type SeatsServiceServer interface {
	CreateSeatsUpdate(context.Context, *CreateSeatsUpdateRequest) (*Seats, error)
	ReverseSeatsUpdate(context.Context, *ReverseSeatsUpdateRequest) (*ReverseSeatsUpdateResponse, error)
	GetSeatsByID(context.Context, *SeatsIdentifierRequest) (*Seats, error)
	GetSeatsByTicketID(context.Context, *SeatsIdentifierByTicketIDRequest) (*Seats, error)
	GetSeatsByTransportID(context.Context, *SeatsIdentifierByTransportIDRequest) (*ListSeats, error)
	GetSeatsAll(context.Context, *SeatsFilterQuery) (*ListSeats, error)
	mustEmbedUnimplementedSeatsServiceServer()
}

// UnimplementedSeatsServiceServer must be embedded to have forward compatible implementations.
type UnimplementedSeatsServiceServer struct {
}

func (UnimplementedSeatsServiceServer) CreateSeatsUpdate(context.Context, *CreateSeatsUpdateRequest) (*Seats, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateSeatsUpdate not implemented")
}
func (UnimplementedSeatsServiceServer) ReverseSeatsUpdate(context.Context, *ReverseSeatsUpdateRequest) (*ReverseSeatsUpdateResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ReverseSeatsUpdate not implemented")
}
func (UnimplementedSeatsServiceServer) GetSeatsByID(context.Context, *SeatsIdentifierRequest) (*Seats, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetSeatsByID not implemented")
}
func (UnimplementedSeatsServiceServer) GetSeatsByTicketID(context.Context, *SeatsIdentifierByTicketIDRequest) (*Seats, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetSeatsByTicketID not implemented")
}
func (UnimplementedSeatsServiceServer) GetSeatsByTransportID(context.Context, *SeatsIdentifierByTransportIDRequest) (*ListSeats, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetSeatsByTransportID not implemented")
}
func (UnimplementedSeatsServiceServer) GetSeatsAll(context.Context, *SeatsFilterQuery) (*ListSeats, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetSeatsAll not implemented")
}
func (UnimplementedSeatsServiceServer) mustEmbedUnimplementedSeatsServiceServer() {}

// UnsafeSeatsServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to SeatsServiceServer will
// result in compilation errors.
type UnsafeSeatsServiceServer interface {
	mustEmbedUnimplementedSeatsServiceServer()
}

func RegisterSeatsServiceServer(s grpc.ServiceRegistrar, srv SeatsServiceServer) {
	s.RegisterService(&SeatsService_ServiceDesc, srv)
}

func _SeatsService_CreateSeatsUpdate_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateSeatsUpdateRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SeatsServiceServer).CreateSeatsUpdate(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.seats.SeatsService/CreateSeatsUpdate",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SeatsServiceServer).CreateSeatsUpdate(ctx, req.(*CreateSeatsUpdateRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _SeatsService_ReverseSeatsUpdate_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ReverseSeatsUpdateRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SeatsServiceServer).ReverseSeatsUpdate(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.seats.SeatsService/ReverseSeatsUpdate",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SeatsServiceServer).ReverseSeatsUpdate(ctx, req.(*ReverseSeatsUpdateRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _SeatsService_GetSeatsByID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SeatsIdentifierRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SeatsServiceServer).GetSeatsByID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.seats.SeatsService/GetSeatsByID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SeatsServiceServer).GetSeatsByID(ctx, req.(*SeatsIdentifierRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _SeatsService_GetSeatsByTicketID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SeatsIdentifierByTicketIDRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SeatsServiceServer).GetSeatsByTicketID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.seats.SeatsService/GetSeatsByTicketID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SeatsServiceServer).GetSeatsByTicketID(ctx, req.(*SeatsIdentifierByTicketIDRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _SeatsService_GetSeatsByTransportID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SeatsIdentifierByTransportIDRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SeatsServiceServer).GetSeatsByTransportID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.seats.SeatsService/GetSeatsByTransportID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SeatsServiceServer).GetSeatsByTransportID(ctx, req.(*SeatsIdentifierByTransportIDRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _SeatsService_GetSeatsAll_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SeatsFilterQuery)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SeatsServiceServer).GetSeatsAll(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.seats.SeatsService/GetSeatsAll",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SeatsServiceServer).GetSeatsAll(ctx, req.(*SeatsFilterQuery))
	}
	return interceptor(ctx, in, info, handler)
}

// SeatsService_ServiceDesc is the grpc.ServiceDesc for SeatsService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var SeatsService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "master.seats.SeatsService",
	HandlerType: (*SeatsServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "CreateSeatsUpdate",
			Handler:    _SeatsService_CreateSeatsUpdate_Handler,
		},
		{
			MethodName: "ReverseSeatsUpdate",
			Handler:    _SeatsService_ReverseSeatsUpdate_Handler,
		},
		{
			MethodName: "GetSeatsByID",
			Handler:    _SeatsService_GetSeatsByID_Handler,
		},
		{
			MethodName: "GetSeatsByTicketID",
			Handler:    _SeatsService_GetSeatsByTicketID_Handler,
		},
		{
			MethodName: "GetSeatsByTransportID",
			Handler:    _SeatsService_GetSeatsByTransportID_Handler,
		},
		{
			MethodName: "GetSeatsAll",
			Handler:    _SeatsService_GetSeatsAll_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "proto/master/seats/seats.proto",
}
